// aduioTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "aduioTest.h"
#include "aduioTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAduioTestDlg dialog

CAduioTestDlg::CAduioTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAduioTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAduioTestDlg)
		// NOTE: the ClassWizard will add member initialization here
		
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAduioTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAduioTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAduioTestDlg, CDialog)
	//{{AFX_MSG_MAP(CAduioTestDlg)
	ON_BN_CLICKED(IDC_SPEAKER, OnSpeaker)
	ON_BN_CLICKED(IDC_MICROPHONE, OnMicrophone)
	ON_BN_CLICKED(IDC_DUPLEX, OnDuplex)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////
#include "wavefile.h"
// for play sound
#define MRCHECK(r,str,label)\
    if ((r != MMSYSERR_NOERROR)) { RETAILMSG(1, (TEXT(#str), TEXT(" failed. mr=%08x\r\n"), r)); mr = r; goto label;}
// for record
#define NELEMS(a) (sizeof(a)/sizeof((a)[0]))
#define MRCHECK2(mr,str)\
    if ((mr != MMSYSERR_NOERROR)) { RETAILMSG(1, (TEXT(#str) TEXT(" failed. mr=%08x\r\n"), mr)); goto ERROR_DONE;}

BOOL checkAudioDriver()
{
	UINT		totalWaveInDev = 0, totalWaveOutDev;

	totalWaveInDev =  waveInGetNumDevs();
	totalWaveOutDev =  waveOutGetNumDevs(); 

	RETAILMSG(1, (TEXT("Check Audio Driver: WaveInDev=%d, WaveOutDev=%d\r\n"), 
		totalWaveInDev, waveOutGetNumDevs));
	if(totalWaveInDev==0) {
		MessageBox(	NULL, 
					TEXT("totalWaveInDev = 0\r\nLoad Other Image which Support Audio Driver\r\nTest Exit!!!"), 
					TEXT("ERROR"), 
					MB_ICONSTOP);
		return FALSE;
	}
	if(totalWaveOutDev==0) {
		MessageBox(	NULL, 
					TEXT("totalWaveOutDev = 0\r\nLoad Other Image which Support Audio Driver\r\nTest Exit!!!"), 
					TEXT("ERROR"), 
					MB_ICONSTOP);
		return FALSE;
	}
	return TRUE;
}


MMRESULT
PlayFile(LPCTSTR pszFilename)
{ MMRESULT mr;
  DWORD dwBufferSize;
  PBYTE pBufferBits = NULL;
  PWAVEFORMATEX pwfx = NULL;
  DWORD dwSlop;
  DWORD dwWait; 
  DWORD dwDuration, rtnVolume;
  
    HANDLE hevDone = CreateEvent(NULL, FALSE, FALSE, NULL);
    if (hevDone == NULL) {
        return MMSYSERR_NOMEM;
    }
    mr = ReadWaveFile(pszFilename,&pwfx,&dwBufferSize,&pBufferBits);
    MRCHECK(mr, ReadWaveFile, ERROR_READ);

    dwDuration = dwBufferSize * 1000 / pwfx->nSamplesPerSec;

    RETAILMSG(1, (TEXT("\"%s\" %c%02d %5dHz %6d bytes %5d ms\r\n")
        , pszFilename
        , pwfx->nChannels == 2 ? L'S' : L'M' 
        , pwfx->wBitsPerSample
        , pwfx->nSamplesPerSec
        , dwBufferSize
        , dwDuration
        ));
    HWAVEOUT hwo;
    mr = waveOutOpen(&hwo, 0, pwfx, (DWORD) hevDone, NULL, CALLBACK_EVENT);
    MRCHECK(mr, waveOutOpen, ERROR_OPEN);

	//CK:
	waveOutGetVolume(hwo, &rtnVolume);
	RETAILMSG(1, (TEXT("Volume = 0x%x\r\n"), rtnVolume));
    WAVEHDR hdr;
    memset(&hdr, 0, sizeof(hdr));
    hdr.dwBufferLength = dwBufferSize;
    hdr.lpData = (char *) pBufferBits;
    mr = waveOutPrepareHeader(hwo, &hdr, sizeof(hdr));
    MRCHECK(mr, waveOutPrepareHeader, ERROR_PLAY);
    mr = waveOutWrite(hwo, &hdr, sizeof(hdr));
    MRCHECK(mr, waveOutWrite, ERROR_PLAY);
    // wait for play + 1 second slop
    dwSlop = 1000;
    dwWait = WaitForSingleObject(hevDone, dwDuration + dwSlop); 
    if (dwWait != WAIT_OBJECT_0) {
        // not much to here, other than issue a warning
        RETAILMSG(1, (TEXT("Timeout waiting for playback to complete\r\n")));
    }
    mr = waveOutUnprepareHeader(hwo, &hdr, sizeof(hdr));
    MRCHECK(mr, waveOutUnprepareHeader, ERROR_PLAY);
ERROR_PLAY:
    mr = waveOutClose(hwo);
    MRCHECK(mr, waveOutClose, ERROR_OPEN);
ERROR_OPEN:
    delete [] pBufferBits;
    delete [] pwfx;
ERROR_READ:
    CloseHandle(hevDone);
    return mr;
}

//No UI
BOOL TestSpeaker()
{
	HRSRC		hResInfo=NULL;
	HANDLE		hRes;
	HINSTANCE	g_hInstance;
	HANDLE		hInstance;
	LPTSTR		lpRes;	
	BOOL		playSndRtn=0;

	if(checkAudioDriver()!=TRUE)
		goto playFailed;
	////////////////////////////////
	hInstance = AfxGetApp()->m_hInstance; 
	g_hInstance = (HINSTANCE)hInstance;
	//Find the resource		
	hResInfo = FindResource(g_hInstance, MAKEINTRESOURCE(IDR_WAVEBVT7), TEXT("WAVE"));
	if (hResInfo == NULL){
		MessageBox(NULL, TEXT("Find Sound Resource Failed!!!\r\n"), TEXT("ERROR"), MB_OK);
		goto playFailed;
	}	
	//Load the resource
	hRes = LoadResource(g_hInstance, hResInfo);
	if (hRes == NULL){
		MessageBox(NULL, TEXT("Load Sound Resource Failed!!!\r\n"), TEXT("ERROR"), MB_OK);
		goto playFailed;
	}
	//Lock the resource
	lpRes = (unsigned short *)LockResource(hRes);
	if (lpRes == NULL){
		MessageBox(NULL, TEXT("Lock Sound Resource Failed!!!\r\n"), TEXT("ERROR"), MB_OK);
		goto playFailed;
	}	
	//Play Sound
	if (!sndPlaySound( lpRes, SND_SYNC | SND_RESOURCE | SND_NODEFAULT ))
		goto playFailed;
	return TRUE;
	//////////////////////////////////////////////////////////////////////
playFailed:
	return FALSE;
}

void LogWaveDevCaps( TCHAR *pLog, UINT uDeviceID, WAVEOUTCAPS *pWOC )
{
    wsprintf(pLog, TEXT("%s%s %s%s"), pLog, 
		TEXT("Product:"), pWOC->szPname, TEXT("\r\n") );
    wsprintf(pLog, TEXT("%s%s"), pLog, 
		TEXT("Supported audio formats:\r\n"));
    if( pWOC->dwFormats & WAVE_FORMAT_1M08 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("11.025 kHz, Mono,   8-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_1S08 )
		wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("11.025 kHz, Stereo, 8-bit\r\n") );  
    if( pWOC->dwFormats & WAVE_FORMAT_1M16 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("11.025 kHz, Mono,   16-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_1S16 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("11.025 kHz, Stereo, 16-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_2M08 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("22.050 kHz, Mono,   8-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_2S08 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("22.050 kHz, Stereo, 8-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_2M16 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("22.050 kHz, Mono,   16-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_2S16 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("22.050 kHz, Stereo, 16-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_4M08 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("44.100 kHz, Mono,   8-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_4S08 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("44.100 kHz, Stereo, 8-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_4M16 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("44.100 kHz, Mono,   16-bit\r\n") );
    if( pWOC->dwFormats & WAVE_FORMAT_4S16 )
        wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("44.100 kHz, Stereo, 16-bit\r\n") );
} 



///////////////////////////////
//

MMRESULT
RecordWaveBuffer (PWAVEHDR pwh, DWORD dwDeviceId, PWAVEFORMATEX pwfx, DWORD dwDuration)
{ 
	const DWORD dwTolerance = 1000;
	DWORD dwWait;
	HANDLE hevDone;
	HWAVEIN hwi;

    // create an event so we know when capture is completed
    hevDone = CreateEvent(NULL, FALSE, FALSE, NULL);
    if (hevDone == NULL) {
        RETAILMSG(1, (TEXT("Unable to create completion event\r\n")));
        return MMSYSERR_NOMEM;
    }
    // open the wave capture device
    MMRESULT mr = waveInOpen(&hwi, dwDeviceId, pwfx, (DWORD) hevDone, NULL, CALLBACK_EVENT);
    if (mr != MMSYSERR_NOERROR) {
        RETAILMSG(1, (TEXT("waveInOpen failed. mr=%08x\r\n"), mr));
        return mr;
    }
    // set up the WAVEHDR structure that describes the capture buffer
    // prepare the buffer for capture
    mr = waveInPrepareHeader(hwi, pwh, sizeof(WAVEHDR));
    MRCHECK2(mr, waveInPrepareHeader);
    // submit the buffer for capture
    mr = waveInAddBuffer(hwi, pwh, sizeof(WAVEHDR));
    MRCHECK2(mr, waveInAddBuffer);
    // start capturing
    RETAILMSG(1, (TEXT("Starting capture...\r\n")));
    mr = waveInStart(hwi);
    MRCHECK2(mr, waveInStart);
    // wait for completion + 1 second tolerance
    dwWait= WaitForSingleObject(hevDone, dwDuration + dwTolerance); 
    if (dwWait != WAIT_OBJECT_0) {
        RETAILMSG(1, (TEXT("Timeout waiting for capture to complete, writing partialy file.\r\n")));
        mr = waveInReset(hwi);
        if (mr != MMSYSERR_NOERROR) {
            RETAILMSG(1, (TEXT("warning: waveInReset failed. mr=%08x\r\n"), mr));
        }
    }
    // now clean up: unprepare the buffer
    mr = waveInUnprepareHeader(hwi, pwh, sizeof(WAVEHDR));
    MRCHECK2(mr, waveInUnprepareHeader);
ERROR_DONE:
    // close the capture device & free the event handle
    mr = waveInClose(hwi);
    if (mr != MMSYSERR_NOERROR) {
        RETAILMSG(1, (TEXT("warning: waveInClose failed. mr=%08x\r\n"), mr));
    }
    CloseHandle(hevDone);
    return mr;
}

MMRESULT
RecordWaveFile (PCTSTR pszFilename, DWORD dwDeviceId, PWAVEFORMATEX pwfx, DWORD dwDuration)
{ 
	MMRESULT mr;
	PBYTE pBufferBits;
	DWORD dwBufferSize;

    // compute the size of the capture buffer
    // compute total # of samples & multiply by blocksize to get sample-aligned buffer size
    dwBufferSize = (dwDuration * pwfx->nSamplesPerSec / 1000) * pwfx->nBlockAlign;
    // let user know what's going on
    RETAILMSG(1, (TEXT("Recording %5d ms to \"%s\": %c%02d %5dHz (%8d bytes)\r\n")
        , dwDuration
        , pszFilename
        , pwfx->nChannels == 2 ? L'S' : L'M' 
        , pwfx->wBitsPerSample
        , pwfx->nSamplesPerSec
        , dwBufferSize
        ));
    // try to allocate the capture buffer
    pBufferBits = new BYTE [dwBufferSize];
    if (pBufferBits == NULL) {
        RETAILMSG(1, (TEXT("Unable to allocate %d bytes for %d ms of audio data\r\n"), dwBufferSize, dwDuration));
        return MMSYSERR_NOMEM;
    }
    WAVEHDR hdr;
    memset(&hdr, 0, sizeof(WAVEHDR));
    hdr.dwBufferLength = dwBufferSize;
    hdr.lpData = (char *) pBufferBits;
    mr = RecordWaveBuffer(&hdr, dwDeviceId, pwfx, dwDuration);
    MRCHECK2(mr, RecordWaveBuffer);
    // finally, write the captured buffer to the file
    // note that we use hdr.dwBytesRecorded, not dwBuffersize.
    RETAILMSG(1, (TEXT("Capture completed. Writing %s\r\n"), pszFilename));
    mr = WriteWaveFile(pszFilename, pwfx, hdr.dwBytesRecorded, pBufferBits);
    MRCHECK2(mr, WriteWaveFile);
ERROR_DONE:
    // free up the capture buffer and release the done event
    delete [] pBufferBits;
    // and we're done
    return mr;
}

HANDLE hReadyToPlay;
void CAduioTestDlg::OnMicrophone() 
{
	TCHAR debug[128];
    // The run parameters
    // Set up defaults to be overridden by command line
    PTSTR pszFilename = TEXT("wavrec.wav");
    DWORD dwDuration = 5 * 1000;    // record for 5 seconds
    DWORD dwChannels = 1;           // default to mono, 2 is Stereo
    DWORD dwBitsPerSample = 16;     // default to 16-bit samples
    DWORD dwSampleRate = 11025;     // default to 11.025KHz sample rate
    DWORD dwDeviceId = 0;           // capture from device 0
	TCHAR text[32];
	
	if(checkAudioDriver()!=TRUE)
		return;

	dwDuration = GetDlgItemInt(IDC_DURATION);
	dwSampleRate = GetDlgItemInt(IDC_SAMPLE_RATE);
	dwBitsPerSample = GetDlgItemInt(IDC_SAMPLE_SIZE);
	GetDlgItemText(IDC_MODE, text, sizeof(text));
	if (text[0] = 'S')
		dwChannels = 2;
	else
		dwChannels = 1;
	getVolume_UI();
	// set up the wave format structure
    WAVEFORMATEX wfx;
    wfx.cbSize = 0;
    wfx.wFormatTag = WAVE_FORMAT_PCM;
    wfx.wBitsPerSample = (WORD) dwBitsPerSample;
    wfx.nSamplesPerSec = dwSampleRate;
    wfx.nChannels = (WORD) dwChannels;
    wfx.nBlockAlign = wfx.nChannels * wfx.wBitsPerSample / 8;
    wfx.nAvgBytesPerSec = wfx.nBlockAlign * wfx.nSamplesPerSec;
    // we're all set: go do the real work
	wsprintf(debug, TEXT("Recording for %d second..."), dwDuration/1000);
	SetDlgItemText(IDC_RESULT, debug);
    RecordWaveFile(pszFilename, dwDeviceId, &wfx, dwDuration);
	SetDlgItemText(IDC_RESULT, TEXT("REC Done... Play back..."));
	PlayFile(TEXT("wavrec.wav"));
	if( MessageBox(TEXT("Did you hear sound?"), 
		TEXT("QUESTION"), 
		MB_ICONQUESTION | MB_YESNO) == IDYES)
		SetDlgItemText(IDC_RESULT, TEXT("Passed: Microphone Test"));
	else
		SetDlgItemText(IDC_RESULT, TEXT("Failed: Microphone Test"));
}

//////////////////////////////////////////////////////////////////////
#define TITLE_MAIN TEXT("Audio Input, Output and Full Duplex Test") 
// Set up defaults to be overridden by command line
PTSTR pszFilename = TEXT("wavrec.wav");
DWORD dwDuration = 5 * 1000;    // record for 5 seconds
DWORD dwChannels = 1;           // default to mono
DWORD dwBitsPerSample = 16;     // default to 16-bit samples
DWORD dwSampleRate = 11025;     // default to 11.025KHz sample rate
DWORD dwDeviceId = 0;           // capture from device 0
WAVEFORMATEX wfx;

DWORD WINAPI recWaveThread(LPVOID lp)
{
	HWND hMain = FindWindow(TEXT("Dialog"), TITLE_MAIN);
	HWND hResult = GetDlgItem(hMain, IDC_RESULT);
	// Sync with play thread
	SetEvent(hReadyToPlay);
    // we're all set: go do the real work
	SetWindowText(hResult, TEXT("Recording while playing sound..."));
    RecordWaveFile(pszFilename, dwDeviceId, &wfx, dwDuration);
	SetWindowText(hResult, TEXT("REC DONE and Playing Back..."));
	// Play back after REC
	PlayFile(TEXT("wavrec.wav"));
	SetWindowText(hResult, TEXT("Play Back Recorded Sound Done"));
	//Verify
	if( MessageBox(NULL, TEXT("Full Duplex Test\r\nDid you hear two sounds?\r\n"), 
		TEXT("QUESTION"), MB_YESNO | MB_ICONQUESTION) == IDYES)
		SetWindowText(hResult, TEXT("PASSED: Full Duplex Test"));
	else
		SetWindowText(hResult, TEXT("FAILED: Full Duplex Test"));
	return 1;
}
DWORD WINAPI playWaveThread(LPVOID lp)
{
	WaitForSingleObject(hReadyToPlay, 2000);
	Sleep(100);
    //PlayFile(TEXT("WAVEBVT7.WAV"));
	TestSpeaker();
	return 1;
}

/////////////////////////////////////////////////////////////////////////////
// CAduioTestDlg message handlers

BOOL CAduioTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	////////////////////////////////////////
	TCHAR			*pLog;
	int				nIdx = 0;
	WAVEOUTCAPS     wocDevice;
	WAVEINCAPS		wicDevice;
	MMRESULT		mmRtn;
	DWORD			rtnVolume, currentPos;
	
	//Dialog Box Init
	m_status		= (CEdit *) GetDlgItem(IDC_STATUS);
	m_sample_rate	= (CEdit *) GetDlgItem(IDC_SAMPLE_RATE);
	m_sample_size   = (CEdit *) GetDlgItem(IDC_SAMPLE_SIZE);
	m_duration		= (CEdit *) GetDlgItem(IDC_DURATION);
	m_mode			= (CEdit *) GetDlgItem(IDC_MODE);
	m_volume        = (CSliderCtrl *) GetDlgItem(IDC_VOLUME);

	m_status->SetWindowText(TEXT(""));
	m_sample_rate->SetWindowText(TEXT("11025"));
	m_sample_size->SetWindowText(TEXT("16"));
	m_mode->SetWindowText(TEXT("Stereo"));
	m_duration->SetWindowText(TEXT("5000"));
	m_volume->SetRange(0, 0xffff); //16bit

	// Standart Method; however our audio doesn't work this way 08/25/2003
	//HWAVEOUT		hwo;
	//MMRESULT		mr;
	//PWAVEFORMATEX	pwfx = NULL;
	//HANDLE		hevDone;
    //hevDone = CreateEvent(NULL, FALSE, FALSE, NULL);
    //mr = waveOutOpen(&hwo, 0, pwfx, (DWORD) hevDone, NULL, CALLBACK_EVENT);
	//waveOutGetVolume(hwo, &rtnVolume);	
	waveOutGetVolume(0, &rtnVolume);//HWAVEOUT handle=0; our driver used this value
	//waveOutClose(hwo);
	RETAILMSG(1, (TEXT("Get Volume = 0x%x\r\n"), rtnVolume));
	currentPos = rtnVolume & 0xffff;
	RETAILMSG(1, (TEXT("Slider Control Current 16 Bit Position=0x%x; Max=0xffff\r\n"), currentPos));
	m_volume->SetPos(currentPos);
	pLog = (TCHAR *) malloc(1024);
	if (pLog ==NULL)
		MessageBox(TEXT("Cannot allocate memory\r\n"), TEXT("ERROR"), MB_OK);
	wsprintf(pLog, TEXT("%s"), TEXT(""));
    mmRtn = waveOutGetDevCaps( nIdx, &wocDevice, sizeof(WAVEOUTCAPS) );   
	if (mmRtn != MMSYSERR_NOERROR){
		wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("Error to get wave output device capabilities!!!"));
		goto exit;
	}
    mmRtn = waveInGetDevCaps( nIdx, &wicDevice, sizeof(WAVEINCAPS) );   
	if (mmRtn != MMSYSERR_NOERROR) {
		wsprintf(pLog, TEXT("%s%s"), pLog, TEXT("Error to get wave input device capabilities!!!"));
		goto exit;
	}
	LogWaveDevCaps(pLog, nIdx, &wocDevice );
exit:
	m_status->SetWindowText(pLog);
	free(pLog);	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CAduioTestDlg::getVolume_UI()
{
	DWORD volume, volumeLow, volumeHigh;
	//Set Volume from UI
	volumeLow = m_volume->GetPos();
	volumeHigh =  ((((volumeLow<<4)<<4)<<4)<<4);
	volume = volumeLow + volumeHigh;
	RETAILMSG(1, (TEXT("\r\nSet Volume = 0x%x; %%%d of Max Value\r\n"), volume, volumeLow*100/0xffff));
	waveOutSetVolume(0, volume);
}

void CAduioTestDlg::OnSpeaker() 
{
	getVolume_UI();
    
	//PlayFile(TEXT("WAVEBVT7.WAV"));
	SetDlgItemText(IDC_RESULT, TEXT("Playing Wave File"));
	//Set Volume from UI
	//Play Sound
	if( TestSpeaker())
		SetDlgItemText(IDC_RESULT, TEXT("Passed: Speaker Test"));
	else
		SetDlgItemText(IDC_RESULT, TEXT("FAILED: Speaker Test"));
}

void CAduioTestDlg::OnDuplex() 
{
	TCHAR text[32];

	if(checkAudioDriver()!=TRUE)
		return;
	//Get Test Parameters from UI
	dwDuration = GetDlgItemInt(IDC_DURATION);
	dwSampleRate = GetDlgItemInt(IDC_SAMPLE_RATE);
	dwBitsPerSample = GetDlgItemInt(IDC_SAMPLE_SIZE);
	GetDlgItemText(IDC_MODE, text, sizeof(text));
	if (text[0] = 'S')
		dwChannels = 2;
	else
		dwChannels = 1;
	getVolume_UI();
	// set up the wave format structure
    wfx.cbSize = 0;
    wfx.wFormatTag = WAVE_FORMAT_PCM;
    wfx.wBitsPerSample = (WORD) dwBitsPerSample;
    wfx.nSamplesPerSec = dwSampleRate;
    wfx.nChannels = (WORD) dwChannels;
    wfx.nBlockAlign = wfx.nChannels * wfx.wBitsPerSample / 8;
    wfx.nAvgBytesPerSec = wfx.nBlockAlign * wfx.nSamplesPerSec;
	SetDlgItemText(IDC_RESULT, TEXT("REC and PLAY sound..."));
	hReadyToPlay = CreateEvent(NULL, 0, 0, NULL);
	CreateThread(NULL, 0, recWaveThread, NULL, 0, NULL);
	CreateThread(NULL, 0, playWaveThread, NULL, 0, NULL);
}


void CAduioTestDlg::OnTest() 
{
	HWAVEOUT		hwo;
	MMRESULT		mr;
	PWAVEFORMATEX	pwfx = NULL;
	HANDLE			hevDone;
	DWORD			rtnVolume;

    hevDone = CreateEvent(NULL, FALSE, FALSE, NULL);
    mr = waveOutOpen(&hwo, 0, pwfx, (DWORD) hevDone, NULL, CALLBACK_EVENT);
	//waveOutSetVolume(0, 0xffffffff);
	waveOutGetVolume(0, &rtnVolume);
	RETAILMSG(1, (TEXT("Volume = 0x%x\r\n"), rtnVolume));
	waveOutClose(hwo);

}
